function Create(self)
	function ResetTarget(self)
		self.timing = SelectRand(180, 220)
		self.ray = true
		self.fire = false
		self.valid = 3
		self.trgAng = nil
		self.TrgVel = nil
		self.trgDist = nil
		
		table.remove(self.Targets, self.ti)
		
		if #self.Targets > 0 then
			self.ti = SelectRand(1, #self.Targets + 1)
		else
			self.ti = nil
		end
	end
	
	self.GunTimer = Timer()
	self.ReloadTimer = Timer()
	self.UpdateTimer = Timer()
	self.Barrel = nil
	self.gunAng = 1.571
	self.maxAmmo = 3
	self.ammo = self.maxAmmo
	self.reloadTime = 1500
	self.rof = 370
	self.rotSpeed = 0
	self.multi = 1100 * TimerMan.DeltaTimeSecs	-- bullet vel(pix/s) * dt
	self.factor = FrameMan.PPM * TimerMan.DeltaTimeSecs
	self.Targets = {}

	if not UAV.TrtCtrl then
		UAV.TrtCtrl = {}
	end
	
	if not UAV.Turrets then
		UAV.Turrets = {}
	end
	
	self.index = #UAV.Turrets + 1
	UAV.Turrets[self.index] = true
	
	ResetTarget(self)
end

function Destroy(self)
	if MovableMan:ValidMO(self.Barrel) and self.Barrel.PresetName == "Flak Barrel" then
		self.Barrel:GibThis()
	end
	
	UAV.Turrets[self.index] = nil
end

function Update(self)
	if UAV.TrtCtrl[self.Team] then
		if #self.Targets > 0 then	-- Track existing target
			if self.UpdateTimer:IsPastSimMS(self.timing) then
				if MovableMan:ValidMO(self.Targets[self.ti]) and self.Targets[self.ti] ~= "Entity" and not self.Targets[self.ti]:IsDead() then
					self.UpdateTimer:Reset()
					if not self.TrgVel then
						self.trgAng = SceneMan:ShortestDistance(self.Pos, self.Targets[self.ti].Pos, false).AbsRadAngle
						self.TrgVel = Vector(self.Targets[self.ti].Vel.X, self.Targets[self.ti].Vel.Y)	-- Target's previous velocity
						self.timing = 80
					else
						local Acc = (self.Targets[self.ti].Vel - self.TrgVel)/5	-- Estimate acceleration
						local PredPos = Vector(self.Targets[self.ti].Pos.X, self.Targets[self.ti].Pos.Y)
						local Dist = SceneMan:ShortestDistance(self.Pos, PredPos, false)
						local Updt2Hit = math.floor(Dist.Magnitude/self.multi)
						local Vel = Vector(self.Targets[self.ti].Vel.X, self.Targets[self.ti].Vel.Y)
						
						for i = 1, Updt2Hit do
							Vel = Vel + Acc
							PredPos = PredPos + Vel * self.factor
						end
						
						--[[ Debug
						local Dot = CreateMOSParticle("Eye", "Debug.rte")
						Dot.Pos = PredPos
						MovableMan:AddParticle(Dot)
						-- End debug]]
						
						if self.Pos.Y > PredPos.Y then
							self.TrgVel = Vector(self.Targets[self.ti].Vel.X, self.Targets[self.ti].Vel.Y)	-- Target's previous velocity
							Dist = SceneMan:ShortestDistance(self.Pos, PredPos, false)
							self.trgDist = Dist.Magnitude
							if self.trgDist < 1000 then
								self.trgAng = Dist.AbsRadAngle
								self.fire = true
							elseif self.fire or self.valid < 1 then	-- Target moved out of range
								ResetTarget(self)
							else
								self.valid = self.valid - 1
							end
						else
							ResetTarget(self)
						end
					end
				else
					ResetTarget(self)
				end
			end
		elseif UAV.Token == self.index and self.search then	-- Search for target
			self.search = false
			local Dist = nil
			for Act in MovableMan.Actors do
				if Act.Team ~= self.Team and self.Pos.Y > Act.Pos.Y and not(Act:IsDead() or Act:IsStatus(Actor.DYING)) and Act.ClassName ~= "Entity" then
					Dist = SceneMan:ShortestDistance(self.Pos, Act.Pos, false)
					if Dist.Magnitude < 1000 then
						table.insert(self.Targets, Act)
						if #self.Targets > 2 then
							break
						end
					end
				end
			end
			
			local Dot = CreateMOPixel("Small Blue Glow", "UAV.rte")
			Dot.Pos = self.Pos + self:RotateOffset(Vector(9,-9))
			Dot.Age = 1
			MovableMan:AddParticle(Dot)
			
			if #self.Targets > 0 then
				self.ti = SelectRand(1, #self.Targets + 1)	-- Pick a target at random
			else
				self.trgAng = nil
			end
		elseif UAV.Token ~= self.index then
			self.search = true
		end
		
		if self.ammo < 1 and self.ReloadTimer:IsPastSimMS(self.reloadTime) then
			self.ammo = self.maxAmmo
		end
	end
	
	local rotDiff = 0
	if self.trgAng then	-- Move barrel towards aimpoint
		rotDiff = self.trgAng - self.gunAng
		self.rotSpeed = 0.04
		if self.fire and self.ammo > 0 and math.abs(rotDiff) < 0.1 and self.GunTimer:IsPastSimMS(self.rof) then	-- Fire
			self.GunTimer:Reset()
			
			if self.ray then
				local id = SceneMan:CastMORay(self.Pos, self.Barrel:RotateOffset(Vector(500, 0)), self.ID, 128, false, 8)	-- Ignore grass
				local Targ = MovableMan:GetMOFromID(MovableMan:GetRootMOID(id))
				if Targ and Targ.Team == self.Team then
					self.valid = self.valid - 1
					self.fire = false
				end
			end
			
			if self.fire then
				self.ray = not self.ray
				
				local Trace = self.Barrel:RotateOffset(Vector(300,0))
				local Org = self.Barrel.Pos + self.Barrel:RotateOffset(Vector(25,0))
				if SceneMan:CastObstacleRay(Org, Trace, Vector(), Vector(), self.Barrel.ID, -1, 5) < 0 then
					local Flash = CreateAEmitter("AA Flak Flash", "UAV.rte")
					local Shell = CreateMOSRotating("Flak Shell Timed", "UAV.rte")
					
					Flash.Pos = Org
					Flash.RotAngle = self.gunAng
					Shell.Pos = Flash.Pos
					Shell.Vel = self.Barrel:RotateOffset(Vector(70,RangeRand(-4,4)))
					Shell.Sharpness = math.max(math.floor(self.trgDist * 0.8), 100)
					MovableMan:AddParticle(Flash)
					MovableMan:AddParticle(Shell)
					
					self.ammo = self.ammo - 1
					if self.ammo == 0 then
						self.ReloadTimer:Reset()
					end
				else
					self.valid = self.valid - 1
				end
			end
		end
	else	 	-- No target; move barrel towards pi/2
		rotDiff = 1.571 - self.gunAng
		self.rotSpeed = 0.005
	end
	
	if math.abs(rotDiff) > 0.01 then
		if rotDiff > 0 then
			self.gunAng = math.min(self.gunAng + math.min(self.rotSpeed, rotDiff), self.RotAngle + 2.94)
		else
			self.gunAng = math.max(self.gunAng + math.max(-self.rotSpeed, rotDiff), self.RotAngle + 0.20)
		end
	end
	
	-- Update barrel
	if not (MovableMan:ValidMO(self.Barrel) and self.Barrel.PresetName == "Flak Barrel") then
		self.Barrel = CreateMOSRotating("Flak Barrel")
		MovableMan:AddParticle(self.Barrel)
	end
	
	self.Barrel.Pos = self.Pos + self:RotateOffset(Vector(0, -6))
	self.Barrel.RotAngle = self.gunAng
	self.Barrel.Age = 1
end