function DemoUAV:StartActivity()
	self.SpawnTimer = Timer()
	self.HuntTimer = Timer()
	self.KeyTimer = Timer()
	self.Clock = Timer()
	self.spawnDelay = RangeRand(50000, 70000)
	self.AList = {"Robot 1 Mk2", "Robot 2 Mk2"}
	self.WList = {"AK-47", "AK-47", "Laser Rifle", "Shotgun", "SMG", "Blaster Pistol", "Flak Cannon", "Flak Cannon", "Flak Cannon"}
	self.SList = {"Pistol"}
	self.BList = {"Frag Grenade"}
	self.LZ1 = SceneMan.Scene:GetArea("LZ1")
	self.LZ2 = SceneMan.Scene:GetArea("LZ2")
	self.landLeft = true
	self.debug = false
	self.startGold = 10000
	
	self:SetTeamFunds(self.startGold, Activity.TEAM_1)
	
	-- Check if the player have a brain assigned
	if not self:GetPlayerBrain(Activity.TEAM_1) then
		local brain = CreateActor("Brain Case")
		brain.Pos = Vector(0,1580)
		MovableMan:AddActor(brain)
		self:SetPlayerBrain(brain, Activity.TEAM_1)
		
		-- Set the observation target to the brain, so that if/when it dies, the view flies to it in observation mode
		if brain ~= nil then
			self:SetObservationTarget(brain.Pos, Activity.TEAM_1)
		end
	end
	
	-- Add enemy brain bot
	self.CPUBrain = CreateAHuman("Brain Robot", "Base.rte")
	self.CPUBrain.Pos = SceneMan.Scene:GetArea("Brain"):GetCenterPoint()
	self.CPUBrain.Team = Activity.TEAM_2
	self.CPUBrain.AIMode = Actor.AIMODE_SENTRY
	self.CPUBrain:AddInventoryItem(CreateHDFirearm(self.WList[math.random(#self.WList)], "Base.rte"))
	if PosRand() > 0.8 then
		self.CPUBrain:AddInventoryItem(CreateHDFirearm(self.SList[math.random(#self.SList)], "Base.rte"))
	end
	if PosRand() > 0.3 then
		self.CPUBrain:AddInventoryItem(CreateTDExplosive(self.BList[math.random(#self.BList)], "Base.rte"))
	end
	
	MovableMan:AddActor(self.CPUBrain)
	
	-- Guards
	local Ar = nil
	local Act = nil
	for i = 1, 14 do
		Ar = SceneMan.Scene:GetArea("G" .. i)
		if Ar then
			Act = self:CreateEnemyActor()
			Act.Pos = Ar:GetCenterPoint()
			Act.AIMode = Actor.AIMODE_SENTRY
			
			if i % 2 == 0 then
				Act.HFlipped = true
			else
				Act.HFlipped = false
			end
			
			MovableMan:AddActor(Act)
		end
	end
	
	-- AAA
	for i = 1, 6 do
		Ar = SceneMan.Scene:GetArea("F" .. i)
		if Ar then
			if i % 2 == 0 then
				Act = CreateACrab("Flak Slave Turret", "UAV.rte")
			else
				Act = CreateACrab("50 cal Slave Turret", "UAV.rte")
			end
			
			Act.Pos = Ar:GetCenterPoint()
			Act.AIMode = Actor.AIMODE_SENTRY
			Act.Team = Activity.TEAM_2
			MovableMan:AddActor(Act)
		end
	end
	
	-- Lasers
	for i = 1, 2 do
		Ar = SceneMan.Scene:GetArea("Laser" .. i)
		if Ar then
			Act = CreateACrab("Laser Slave Turret", "UAV.rte")
			Act.Pos = Ar:GetCenterPoint()
			Act.AIMode = Actor.AIMODE_SENTRY
			Act.Team = Activity.TEAM_2
			Act.Sharpness = 2	-- 2 == guard
			MovableMan:AddActor(Act)
		end
	end
	
	-- Turret Control
	Ar = SceneMan.Scene:GetArea("Control")
	if Ar then
		Act = CreateACrab("Turret Control", "UAV.rte")
		Act.Pos = Ar:GetCenterPoint()
		Act.AIMode = Actor.AIMODE_SENTRY
		Act.Team = Activity.TEAM_2
		MovableMan:AddActor(Act)
	end
	
	-- UAV
	local UAV = CreateACRocket("UAV Spawn", "UAV.rte")
	if UAV then
		UAV.Pos = Vector(100, 50)
		UAV.Team = Activity.TEAM_1
		UAV:ReloadScripts()
		MovableMan:AddActor(UAV)
		self:SwitchToActor(UAV, UAV.Team, UAV.Team)
	end
end

function DemoUAV:CreateEnemyActor()
	local Act = CreateAHuman(self.AList[SelectRand(1,#self.AList+1)], "UAV.rte")
	Act.Team = Activity.TEAM_2
	Act.AIMode = Actor.AIMODE_PATROL
	Act:AddInventoryItem(CreateHDFirearm(self.WList[SelectRand(1,#self.WList+1)], "Base.rte"))
	
	if PosRand() < 0.7 then
		Act:AddInventoryItem(CreateHDFirearm(self.SList[SelectRand(1,#self.SList+1)], "Base.rte"))
	end
	
	if PosRand() < 0.3 then
		Act:AddInventoryItem(CreateTDExplosive(self.BList[SelectRand(1,#self.BList+1)], "Base.rte"))
		if PosRand() < 0.5 then
			Act:AddInventoryItem(CreateTDExplosive(self.BList[SelectRand(1,#self.BList+1)], "Base.rte"))
		end
	end
	
	return Act
end

function DemoUAV:UpdateActivity()
	if self.ActivityState == Activity.OVER then
		if self.Msg then
			FrameMan:ClearScreenText(Activity.TEAM_1)
			FrameMan:SetScreenText(self.Msg, Activity.TEAM_1, 0, 3000, true)
		end
	else
		if not MovableMan:ValidMO(self.CPUBrain) then
			self.WinnerTeam = Activity.TEAM_1
			ActivityMan:EndActivity()
			
			local gold = math.ceil((self.startGold+300) - self:GetTeamFunds(Activity.TEAM_1))
			if not self.cheater and gold > 0 then
				self.Msg = "Competed in "
				local minutes = math.floor(self.Clock.ElapsedSimTimeS/60)
				local seconds = math.ceil(self.Clock.ElapsedSimTimeS) - minutes * 60
				self.Msg = "Competed in " .. minutes .. " minutes and " .. seconds .. " seconds, using " .. gold .. " oz of gold"
			else
				self.Msg = nil
			end
		end
		
		if MovableMan:GetMOIDCount() < 160 and self.SpawnTimer:IsPastSimMS(self.spawnDelay) then
			self.SpawnTimer:Reset()
			self.spawnDelay = RangeRand(22000, 36000)
			
			local Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
			if Ship then
				Ship.Team = Activity.TEAM_2
				Ship.Vel = Vector(0, SelectRand(5,20))
				
				if PosRand() < 0.2 and MovableMan:GetMOIDCount() < 130 then
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship.Pos = Vector(self.LZ1:GetCenterPoint().X+SelectRand(-20,20), -50)
					MovableMan:AddActor(Ship)
					
					Ship = CreateACDropShip("Drop Ship MK1", "Base.rte")
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship:AddInventoryItem(self:CreateEnemyActor())
					Ship.Team = Activity.TEAM_2
					Ship.Vel = Vector(0, SelectRand(5,20))
					Ship.Pos = Vector(self.LZ2:GetCenterPoint().X+SelectRand(-20,20), -50)
					MovableMan:AddActor(Ship)
				else
					local spawn = true
					local controller = false
					for Act in MovableMan.Actors do
						if Act.Team == Activity.TEAM_2 then
							if Act.PresetName == "Turret Control" then
								controller = true
							elseif Act.ClassName == "ACrab" and (SceneMan.Scene:WithinArea("AA1", Act.Pos) or SceneMan.Scene:WithinArea("AA2", Act.Pos)) then
								spawn = false
								break
							end
						end
					end
					
					if spawn and controller and MovableMan:GetMOIDCount() < 150 then
						self.spawnDelay = RangeRand(18000, 24000)
						if PosRand() < 0.5 then
							Ship.Pos = Vector(SceneMan.Scene:GetArea("F1"):GetCenterPoint().X, -50)
						else
							Ship.Pos = Vector(SceneMan.Scene:GetArea("F6"):GetCenterPoint().X, -50)
						end
						
						local Turret = CreateACrab("50 cal Slave Turret", "UAV.rte")
						if Turret then
							Turret.Team = Activity.TEAM_2
							Ship:AddInventoryItem(Turret)
						else
							Ship:AddInventoryItem(self:CreateEnemyActor())
						end
						
						Ship.Vel = Vector(0, 5)
						MovableMan:AddActor(Ship)
					elseif MovableMan:GetMOIDCount() < 140 then
						self.landLeft = not self.landLeft
						if self.landLeft then
							Ship.Pos = Vector(self.LZ1:GetCenterPoint().X, -50)
						else
							Ship.Pos = Vector(self.LZ2:GetCenterPoint().X, -50)
						end
						
						Ship:AddInventoryItem(self:CreateEnemyActor())
						Ship:AddInventoryItem(self:CreateEnemyActor())
						Ship.Vel = Vector(0, 5)
						MovableMan:AddActor(Ship)
					end
				end
			end
		elseif self.HuntTimer:IsPastSimMS(5000) then
			self.HuntTimer:Reset()
			
			local Target, Left, Right
			for Act in MovableMan.Actors do
				if Act.ClassName ~= "Entity" then
					if Act.Team == Activity.TEAM_1 then
						if SceneMan.Scene:WithinArea("Reinforce", Act.Pos) then
							Target = Act
						end
					else
						if SceneMan.Scene:WithinArea("Left", Act.Pos) then
							if not Left or Left.Pos.X < Act.Pos.X then
								Left = Act
							end
						elseif SceneMan.Scene:WithinArea("Right", Act.Pos) then
							if not Right or Right.Pos.X < Act.Pos.X then
								Right = Act
							end
						end
					end
				end
			end
			
			if Target then
				local Hunter = nil
				if Left and Right then
					local l = (Target.Pos - Left.Pos).Magnitude
					local r = (Target.Pos - Right.Pos).Magnitude
					if l < r and l < 1000 then
						Hunter = Left
					elseif r < 1000 then
						Hunter = Right
					end
				else
					Hunter = Left or Right
				end
				
				if Hunter then
					Hunter.AIMode = Actor.AIMODE_GOTO
					Hunter:ClearAIWaypoints()
					Hunter:AddAIMOWaypoint(Target)
				end
			end
		end
		
		-- Debug: Spawn craft, activate by pressing ABCI at the same time
		if self.KeyTimer:IsPastSimMS(300) then
			if UInputMan:KeyHeld(1) and UInputMan:KeyHeld(2) and UInputMan:KeyHeld(3) and UInputMan:KeyHeld(9) then
				self.KeyTimer:Reset()
				self.debug = not self.debug
				self.cheater = true
				if self.debug then
					print("Debug mode on")
					self.ScreenShotTimer = Timer()
				else
					print("Debug mode off")
					self.ScreenShotTimer = nil
				end
			elseif self.debug then
				if UInputMan:KeyHeld(6) then	-- F-key
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-A", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(87, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
						
						local Bomb = CreateMOSRotating("High-Drag Bomb Open")
						if Bomb ~= nil then
							Bomb.Pos = Vector(-40, -40)
							Bomb.Vel = Vector(-40, -40)
							Bomb:ReloadScripts()
							MovableMan:AddParticle(Bomb)
						end
						
						Bomb = CreateMOSRotating("High-Drag Bomb")
						if Bomb ~= nil then
							Bomb.Pos = Vector(-50, -50)
							Bomb.Vel = Vector(-50, -50)
							Bomb:ReloadScripts()
							MovableMan:AddParticle(Bomb)
						end
					end
				elseif UInputMan:KeyHeld(7) then	-- G
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-B", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(87, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
					end
					
					Bomb = CreateMOSRotating("Cluster Bomb")
					if Bomb ~= nil then
						Bomb.Pos = Vector(-50, -50)
						Bomb.Vel = Vector(-50, -50)
						Bomb:ReloadScripts()
						MovableMan:AddParticle(Bomb)
					end
				elseif UInputMan:KeyHeld(8) then
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-C", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(87, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
					end
					
					local Rocket = CreateAEmitter("FFAR", "UAV.rte")
					if Rocket ~= nil then
						Rocket.Pos = Vector(-50, -50)
						Rocket.Vel = Vector(-50, -50)
						Rocket:ReloadScripts()
						MovableMan:AddParticle(Rocket)
					end
				elseif UInputMan:KeyHeld(9) then
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-D", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(76, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
					end
				elseif UInputMan:KeyHeld(10) then -- M-key
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-E", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(87, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
						
						local Bomb = CreateADoor("Ball Bomb Right", "UAV.rte")
						if Bomb ~= nil then
							Bomb.Pos = Vector(-50, -50)
							Bomb.Vel = Vector(-50, -50)
							Bomb:ReloadScripts()
							MovableMan:AddActor(Bomb)
						end
					end
				elseif UInputMan:KeyHeld(11) then
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-F", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(76, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
					end
				elseif UInputMan:KeyHeld(12) then
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-G", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(87, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
						
						Bomb = CreateMOSRotating("Fuel Air Bomb", "UAV.rte")
						if Bomb ~= nil then
							Bomb.Pos = Vector(-50, -50)
							Bomb.Vel = Vector(-50, -50)
							Bomb:ReloadScripts()
							MovableMan:AddParticle(Bomb)
						end
					end
				elseif UInputMan:KeyHeld(13) then
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("UAV-J", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(87, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
						
						local Rocket = CreateADoor("Jericho Missile", "UAV.rte")
						if Rocket ~= nil then
							Rocket.Pos = Vector(-50, -50)
							Rocket.Vel = Vector(-50, -50)
							Rocket:ReloadScripts()
							MovableMan:AddActor(Rocket)
						end
						
						Rocket = CreateMOSRotating("Spent Jericho Missile", "UAV.rte")
						if Rocket ~= nil then
							Rocket.Pos = Vector(-20, -20)
							Rocket.Vel = Vector(-50, -50)
							Rocket:ReloadScripts()
							MovableMan:AddParticle(Rocket)
						end
					end
				elseif UInputMan:KeyHeld(14) then
					self.KeyTimer:Reset()
					local Plane = CreateACRocket("Cruise Missile", "UAV.rte")
					if Plane then
						Plane.Pos = Vector(76, 8)
						Plane.Team = Activity.TEAM_1
						print(Plane.PresetName .. " reload = " .. Plane:ReloadScripts())
						MovableMan:AddActor(Plane)
						self:SwitchToActor(ToActor(Plane), Plane.Team, Plane.Team)
					end
				elseif UInputMan:KeyHeld(15) then
					self.KeyTimer:Reset()
					local Act = CreateACrab("Flak Slave Turret", "UAV.rte")
					if Act then
						Act.Pos = SceneMan:MovePointToGround(Vector(RangeRand(1500, 1800), 500), 21, 5)
						Act.Team = Activity.TEAM_2
						print(Act.PresetName .. " reload = " .. Act:ReloadScripts())
						MovableMan:AddActor(Act)
					end
				elseif UInputMan:KeyHeld(16) then
					self.KeyTimer:Reset()
					local Act = CreateACrab("50 cal Slave Turret", "UAV.rte")
					if Act then
						Act.Pos = SceneMan:MovePointToGround(Vector(RangeRand(1100, 1400), 500), 21, 5)
						Act.Team = Activity.TEAM_2
						print(Act.PresetName .. " reload = " .. Act:ReloadScripts())
						MovableMan:AddActor(Act)
					end
				elseif UInputMan:KeyHeld(18) then	-- R
					self.KeyTimer:Reset()
					local Act = CreateAHuman("Robot 2 Mk2", "UAV.rte")
					Act.Team = Activity.TEAM_1
					Act.AIMode = Actor.AIMODE_SENTRY
					Act.Pos = SceneMan:MovePointToGround(Vector(RangeRand(3000, 3200), 500), 21, 5)
					Act:AddInventoryItem(CreateHDFirearm("Heavy Digger", "Base.rte"))
					Act:AddInventoryItem(CreateHDFirearm("Shotgun", "Base.rte"))
					print(Act.PresetName .. " reload = " .. Act:ReloadScripts())
					MovableMan:AddActor(Act)
					self:SwitchToActor(Act, Act.Team, Act.Team)
				elseif UInputMan:KeyHeld(22) then
					self.KeyTimer:Reset()
					self:SetViewState(Activity.ACTORSELECT, Activity.TEAM_1)
				elseif UInputMan:KeyHeld(3) and UInputMan:KeyHeld(24) and UInputMan:KeyHeld(26) then
					self.KeyTimer:Reset()
					for Act in MovableMan.Actors do
						if Act.ClassName == "ACrab" and Act.PresetName ~= "Turret Control" then
							Act:GibThis()
						end
					end
				elseif UInputMan:KeyHeld(2) then	-- B
					self.KeyTimer:Reset()
					self.gif = not self.gif
				end
			end
			
			if self.gif and self.ScreenShotTimer:IsPastSimMS(42) then	-- 24fps
				self.ScreenShotTimer:Reset()
				FrameMan:SaveScreenToBMP("DemoUAV")
			end
		end
	end
end