function Create(self)
	self.Life = Timer()
	
	-- Find the attachable
	local thisID = self.ID
	local MoObj = nil
	
	for i = 1, MovableMan:GetMOIDCount()-1 do
		if MovableMan:GetRootMOID(i) == thisID then	-- an obj without a parent has ID == RootID
			MoObj = MovableMan:GetMOFromID(i)
			if MoObj.ClassName == "Attachable" then
				self.Door = ToAttachable(MoObj)
				break
			end
		end
	end
end

function Update(self)
	if self.Door and self.Door:IsAttached() then
		--[[ Debug
		local Dot = CreateMOSParticle("Yellow", "Debug.rte")
		Dot.Pos = UAV.Offset(self.Door.Pos + Vector(7,-17), Vector(65,60).AbsRadAngle, SelectRand(3, 85))
		MovableMan:AddParticle(Dot)
		-- End debug]]
		
		if self.Life:IsPastSimMS(700) then
			self.Life:Reset()
			
			local MO = SceneMan:CastMORay(self.Door.Pos + Vector(7,-17), Vector(65,60), -1, -1, false, 3)
			if MO < 255 then
				MO = MovableMan:GetMOFromID(MovableMan:GetRootMOID(MO))
				if MO and MO.Team ~= self.Team then
					Emitter = CreateAEmitter("Flame Emitter", "UAV.rte")
					Emitter.Pos = self.Door.Pos + Vector(7,14)
					Emitter.RotAngle = -0.1
					MovableMan:AddParticle(Emitter)
				end
			end
		end
	end
end